/*! ********************************************
 * IGrayBoxModule.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox 
{
public interface IGrayBoxModule
{
// host ---	
	function updateSampleRate(sampleRate:Number):void;
	function updateAudioChannels(ch:int):void;
	function updateProcessBlockSize(size:int):void;
// module ---	
	function resetModule():void;
	function initiModule():void;
	function connectModule(host:GrayBox):void;
	function disconnectModule():void;
	function updateBypassStatus(bypass:Boolean):void;
// process ---
	function startProcess():void;
	function stopProcess():void;
	function suspendProcess():void;
	function resumeProcess():void;
	//function updateProcessingStatus(state:int):void;
	//function preProcess(procData:ProcessData):void;
	function process(procData:ProcessData):void;
	//function postProcess(procData:ProcessData):void;
}
}